;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~ 			**Steuerung einer Last mit einem DA-Wandler** 			   ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 
; 
; **Abfrage der Tastatur
; **Ansteuerung der LCD Anzeige
; **bernahme der eingegebenen Werte in Register
; **Ausgabe der Werte an den Ports zur Ansteuerung des DA-Wandlers
; **Feinabstimmung durch Auf/Abzhlen einzelner Bits
 
; Ausgnge: PortA 0-3 (Tastatur), PortB(LCD-Daten), PortC(LCD-Steuerung)
; 			PortD(higher), PortB(lower)	
; Eingnge: PortA 4-6 (Tastatur)
;
;!!Ab dieser Version nur noch mit zwei Stellen nach dem Komma einlesen!! 
;
;**********Definitionen*************************************************
.include "m16def.inc"


.def vk_save	= r8
.def nk_save	= r13
.def menu_help	= r7
.def temp1		= r8
.def temp2		= r9
.def temp3		= r10
.def temp4		= r11
.def temp5		= r12
.def temp6		= r13
.def zeichen	= r14
.def tempvor 	= r16
.def counter	= r17			;zhlt die Wertigkeit der Ziffern fr Multiplikation	
.def temp  		= r18
.def tempnach	= r19
.def zaehl	    = r20
.def steuer		= r21
.def LCD_out	= r22
.def Stack		= r23
.def data		= r24
.def clear 		= r25			
.def vorkomma	= r26			;hier steht der Wert vor dem Komma 
.def nachkomma	= r28			;hier steht der Wert nach dem Komma
.def kommaset	= r23			;ist mit ff belegt wenn Komma gesetzt
.def zlow		= r30
.def zhigh		= r31
.def time		= r27
.def voltl		= r23
.def volth		= r19
.def volt		= r25
.def spg_anz	= r19
.def spg_anz2	= r6
.def speicher	= r25
.def anf_spg_h	= r8
.def anf_spg_l	= r9
.def end_spg_h	= r10
.def end_spg_l	= r11
.def zeit		= r12
.def anstieg_help	= r6
.def cp_help	= r19


.equ einsx		= 0b00000001
.equ zweix		= 0b00000010
.equ dreix		= 0b00000011
.equ vierx		= 0b00000100
.equ fuenfx		= 0b00000101
.equ sechsx		= 0b00000110
.equ siebenx	= 0b00000111
.equ achtx		= 0b00001000
.equ neunx		= 0b00001001
.equ nullx		= 0b00000000

;.equ spg1_1		= 0x60
;.equ spg1_2		= 0x61
;.equ time1		= 0x62
;.equ spg2_1		= 0x63
;.equ spg2_2		= 0x64
;.equ time2		= 0x65
;.equ spg3_1		= 0x66
;.equ spg3_2		= 0x67
;.equ time3		= 0x68
;.equ spg4_1		= 0x69
;.equ spg4_2		= 0x70
;.equ time4		= 0x71
;.equ spg5_1		= 0x72
;.equ spg5_2		= 0x73
;.equ time5		= 0x74


.cseg
.org 0X00



sei
ldi 	stack, high(RAMEND)		;stack definieren fr rcall-Befehl
out 	SPH, stack
ldi 	stack, low(RAMEND)
out 	SPL, stack

ser 	temp					;Last am Anfang auf 0 Volt 
out 	DDRD, temp				;Ausgang
out 	DDRB, temp 				;Ausgang

rcall	wait15ms
rcall 	initLCD				;Initalisiert LCD*************
;rjmp	timer
rjmp	menu
rjmp 	wait

start:							;Start des eigentlichen Programms


ser 	temp
out 	DDRD, temp				;Ausgang
out 	DDRB, temp 				;Ausgang
ldi 	temp, 0b00001111
out 	DDRA, temp				;Ausgang/Eingang
clr 	temp
clr 	kommaset				;Kommaregister gelscht
clr 	vorkomma				;Wert der vor dem Komma steht lschen
clr 	nachkomma				;Wert der nach dem Komma steht lschen
clr 	counter							
clr 	r26						;Vorkommawert
clr 	r27				
clr 	r28						;Nachkommawert (lower)
clr 	r29						;Nachkommawert (higher)
clr		r30						;Hilfsregister zur Berechnung
clr		r31
ldi		temp,	$00
out 	PortD,	temp
out		PortB,	temp

loop1:							;****Schleifenstart des Hauptprogramms****

								;Z freigeben fr Zeitschleife
mov 	r11,	r30				;Inhalt von Reg.Z in anderem Reg. zwischenspeichern 
mov		r12,	r31

;++++++++++++++++++++++++++		;Zeitschleife da neue Tastatur trger	
								;reagiert als einzelne Taster
	sbr 	zlow, 	$ff 
 	sbr 	zhigh, 	$ff
	ldi		zlow, 	$ff
	ldi		zhigh, 	$ff

	zaehlloop1:				
		sbiw 	zlow, 	1		
		cpi 	zhigh, 	0
		brne 	zaehlloop1
		nop

;++++++++++++++++++++++++++

mov		r30, 	r11				;zurckgeben des alten Wertes in Z Reg.
mov		r31,	r12

ldi 	zaehl, 0b00000001		;Abfrage der Tasten
nop								;Pause sonst wird die 7 nicht erkannt
nop
nop
nop
out 	porta, zaehl
nop
nop
rcall 	clear1						
sbic 	pina, 4		;1			;wenn PinA gedrckt gehe zu Anzeige 1
rcall 	Anzeige1				
sbic 	pina, 4					;wenn PinA gedrckt gehe zu Sieben
rcall 	eins
sbic 	pina, 5		;2			;wenn PinA gedrckt gehe zu Anzeige 2			
rcall 	Anzeige2	
sbic 	pina, 5					;wenn PinA gedrckt gehe zu Acht
rcall 	zwei
rcall 	clear1
sbic 	pina, 6		;3			;wenn PinA gedrckt gehe zu Anzeige 3
rcall 	Anzeige3
sbic 	pina, 6					;wenn PinA gedrckt gehe zu Neun
rcall 	drei
sbic 	pina, 7		;Up			;wenn PinA gedrckt gehe zu Anzeige Up
rcall 	AnzeigeUp
sbic 	pina, 7					;wenn PinA gedrckt gehe zu Up
rcall 	Up 
inc 	zaehl					;erhhe Zaehl um 1
out 	porta, zaehl			;gebe Zaehl an PortA aus

rcall 	clear1

sbic 	pina, 4		;4
rcall 	Anzeige4
sbic 	pina, 4
rcall 	vier
sbic 	pina, 5		;5
rcall 	Anzeige5	
sbic 	pina, 5
rcall 	fuenf
sbic 	pina, 6		;6
rcall 	Anzeige6
sbic 	pina, 6
rcall 	sechs
sbic 	pina, 7		;down
rcall 	AnzeigeDown
sbic 	pina, 7
rcall 	Down
inc 	zaehl
inc 	zaehl
out 	porta, zaehl

rcall 	clear1

sbic 	pina, 4		;7
rcall 	Anzeige7	
sbic 	pina, 4
rcall 	sieben
sbic 	pina, 5		;8
rcall 	Anzeige8	
sbic 	pina, 5
rcall 	acht
sbic 	pina, 6		;9
rcall 	Anzeige9
sbic 	pina, 6
rcall 	neun
;sbic 	pina, 7		;SlowUp
;rcall 	AnzeigeSlowUp
sbic 	pina, 7
rcall	menu
;rcall 	SlowUp

ldi 	zaehl, 0b0001000
out 	porta, zaehl

rcall 	clear1

sbic 	pina, 4		;Komma
rcall 	AnzeigeKomma
sbic 	pina, 4
rcall 	Komma
sbic 	pina, 5		;Null
rcall 	AnzeigeNull
sbic 	pina, 5
rcall 	Null
sbic 	pina, 6 	;Enter
rcall 	AnzeigeEnter
sbic 	pina, 6
rcall 	Enter
;sbic 	pina, 7		;SlowDown
;rcall 	AnzeigeSlowDown
;sbic 	pina, 7
;rcall 	SlowDown


rjmp 	loop1					;wenn kein Taster gedrckt wurde wiederhole Schleife				

Anzeige1:						;Aufrufen der Ausgaberoutinen
	ldi		LCD_out, '1'		;lade 1 als ASCII Zeichen
	rcall 	write_LCD_data		;schreiben der 1 aufs Display
	ret
Anzeige2:
	ldi		LCD_out, '2'
	rcall 	write_LCD_data
	ret
Anzeige3:
	ldi		LCD_out, '3'
	rcall 	write_LCD_data
	ret
Anzeige4:
	ldi		LCD_out, '4'
	rcall 	write_LCD_data
	ret
Anzeige5:
	ldi		LCD_out, '5'
	rcall 	write_LCD_data
	ret
Anzeige6:
	ldi		LCD_out, '6'
	rcall 	write_LCD_data
	ret
Anzeige7:
	ldi		LCD_out, '7'
	rcall 	write_LCD_data
	ret
Anzeige8:
	ldi		LCD_out, '8'
	rcall 	write_LCD_data
	ret
Anzeige9:
	ldi		LCD_out, '9'
	rcall 	write_LCD_data
	ret
AnzeigeNull:
	ldi		LCD_out, '0'
	rcall 	write_LCD_data
	ret
AnzeigeKomma:
	ldi		LCD_out, ','
	rcall 	write_LCD_data
	ret
AnzeigeEnter:
	ldi		LCD_out, 'E'
	rcall 	write_LCD_data
	ret

;***********************Einlesen der Werte ins Register*****************
eins: 		
	sbrc 	kommaset, 0			;berspringe n. Z. wenn kein Komma gesetzt
	rjmp 	nachkomma1			;wenn Komma gesetzt springe zu Nachkomma
	mov 	tempvor, r28		;kopiere 		
	cpi 	counter, 1			;Vergleiche Counter mit 1
	brne 	weiter11			;wenn nicht gesetzt gehe zu end1
	rcall 	VorkommaMulti		;*10
								;gehe zu Ende
weiter11:
	adiw 	vorkomma, einsx		;addiere Wert zu Vorkommaregister
	rjmp 	end11
nachkomma1:
	mov 	tempnach, r26
	cpi 	counter,2
	breq 	end1
	adiw 	nachkomma, einsx	;schreibe Wert in Nachkommaregister	
	rcall 	NachkommaMulti

end11:
	rcall 	clearpin
	inc 	counter
	ret
end1: 
	ret

zwei: 		
	sbrc 	kommaset, 0			;berspringe n. Z. wenn kein Komma gesetzt
	rjmp 	nachkomma2			;wenn Komma gesetzt springe zu Nachkomma
	mov 	tempvor, r28		;kopiere Inhalt von r26 nach r27		
	cpi 	counter, 1			;Vergleiche Counter mit 1
	brne 	weiter21			;wenn nicht gesetzt gehe zu end1
	rcall 	VorkommaMulti		;*10
								;gehe zu Ende
weiter21:
	adiw 	vorkomma, zweix		;schreibe Wert in Vorkommaregister
	rjmp 	end21
nachkomma2:
	mov 	tempnach, r26
	cpi 	counter,2
	breq 	end2
	adiw 	nachkomma, zweix	;schreibe Wert in Nachkommaregister	
	rcall 	NachkommaMulti
end21:
	rcall 	clearpin
	inc 	counter
	ret
end2:
	ret

drei: 		
	sbrc 	kommaset, 0			;berspringe n. Z. wenn kein Komma gesetzt
	rjmp 	nachkomma3			;wenn Komma gesetzt springe zu Nachkomma
	mov 	tempvor, r28		;kopiere Inhalt von r26 nach r27		
	cpi 	counter, 1			;Vergleiche Counter mit 1
	brne 	weiter31			;wenn nicht gesetzt gehe zu end1
	rcall 	VorkommaMulti		;*10
								;gehe zu Ende
weiter31:
	adiw 	vorkomma, dreix		;schreibe Wert in Vorkommaregister
	rjmp 	end21
nachkomma3:	
	mov 	tempnach, r26
	cpi 	counter,2
	breq 	end1
	adiw 	nachkomma, dreix	;schreibe Wert in Nachkommaregister	
	rcall 	NachkommaMulti
end31:
	rcall 	clearpin
	inc 	counter
	ret
end3:
	ret

vier: 		
	sbrc 	kommaset, 0			;berspringe n. Z. wenn kein Komma gesetzt
	rjmp 	nachkomma4			;wenn Komma gesetzt springe zu Nachkomma
	mov 	tempvor, r28		;kopiere Inhalt von r26 nach r27		
	cpi 	counter, 1			;Vergleiche Counter mit 1
	brne 	weiter41			;wenn nicht gesetzt gehe zu end1
	rcall 	VorkommaMulti		;*10
								;gehe zu Ende
weiter41:
	adiw 	vorkomma, vierx		;schreibe Wert in Vorkommaregister
	rjmp 	end41
nachkomma4:
	mov 	tempnach, r26
	cpi 	counter,2
	breq 	end1
	adiw 	nachkomma, vierx	;schreibe Wert in Nachkommaregister	
	rcall 	NachkommaMulti
end41:
	rcall 	clearpin
	inc 	counter
	ret
end4:
	ret

fuenf: 		
	sbrc 	kommaset, 0			;berspringe n. Z. wenn kein Komma gesetzt
	rjmp 	nachkomma5			;wenn Komma gesetzt springe zu Nachkomma
	mov 	tempvor, r28		;kopiere Inhalt von r26 nach r27		
	cpi 	counter, 1			;Vergleiche Counter mit 1
	brne 	weiter51			;wenn nicht gesetzt gehe zu end1
	rcall 	VorkommaMulti		;*10
								;gehe zu Ende
weiter51:
	adiw 	vorkomma, fuenfx		;schreibe Wert in Vorkommaregister
	rjmp 	end51
nachkomma5:
	mov 	tempnach, r26
	cpi 	counter,2
	breq 	end5						;!!!!!!!!!!hier ist verweis nach end1 mglich
	adiw 	nachkomma, fuenfx	;schreibe Wert in Nachkommaregister	
	rcall 	NachkommaMulti	

end51:
	rcall 	clearpin
	inc 	counter
	ret
end5:
	ret

sechs: 		
	sbrc 	kommaset, 0			;berspringe n. Z. wenn kein Komma gesetzt
	rjmp 	nachkomma6			;wenn Komma gesetzt springe zu Nachkomma
	mov 	tempvor, r28		;kopiere Inhalt von r26 nach r27		
	cpi 	counter, 1			;Vergleiche Counter mit 1
	brne 	weiter61			;wenn nicht gesetzt gehe zu end1
	rcall 	VorkommaMulti		;*10
								;gehe zu Ende
weiter61:
	adiw 	vorkomma, sechsx	;schreibe Wert in Vorkommaregister
	rjmp 	end61
nachkomma6:
	
	mov 	tempnach, r26
	cpi 	counter,2
	breq 	end6
	adiw 	nachkomma, sechsx	;schreibe Wert in Nachkommaregister	
	rcall 	NachkommaMulti
end61:
	rcall 	clearpin
	inc 	counter
	ret
end6:	
	ret

sieben: 		
	sbrc 	kommaset, 0			;berspringe n. Z. wenn kein Komma gesetzt
	rjmp 	nachkomma7			;wenn Komma gesetzt springe zu Nachkomma
	mov 	tempvor, r28		;kopiere Inhalt von r26 nach r27		
	cpi 	counter, 1			;Vergleiche Counter mit 1
	brne 	weiter71			;wenn nicht gesetzt gehe zu end1
	rcall 	VorkommaMulti		;*10
								;gehe zu Ende
weiter71:
	adiw 	vorkomma, siebenx	;schreibe Wert in Vorkommaregister
	rjmp 	end71
nachkomma7:
	mov 	tempnach, r26
	cpi 	counter,2
	breq 	end7
	adiw 	nachkomma, siebenx	;schreibe Wert in Nachkommaregister	
	rcall 	NachkommaMulti
end71:
	rcall 	clearpin
	inc 	counter
	ret
end7:
	ret

acht: 		
	sbrc 	kommaset, 0			;berspringe n. Z. wenn kein Komma gesetzt
	rjmp 	nachkomma8			;wenn Komma gesetzt springe zu Nachkomma
	mov 	tempvor, r28		;kopiere Inhalt von r26 nach r27		
	cpi 	counter, 1			;Vergleiche Counter mit 1
	brne 	weiter81			;wenn nicht gesetzt gehe zu weiter81
	rcall 	VorkommaMulti		;*10
								;gehe zu Ende
weiter81:
	adiw 	vorkomma, achtx		;schreibe Wert in Vorkommaregister
	rjmp 	end81
nachkomma8:
	
	mov 	tempnach, r26
	cpi 	counter,2
	breq 	end8
	adiw 	nachkomma, achtx	;schreibe Wert in Nachkommaregister	
	rcall 	NachkommaMulti	

end81:
	rcall 	clearpin
	inc 	counter
	ret
end8:
	ret

neun: 		
	sbrc 	kommaset, 0			;berspringe n. Z. wenn kein Komma gesetzt
	rjmp 	nachkomma9			;wenn Komma gesetzt springe zu Nachkomma
	mov 	tempvor, r28		;kopiere Inhalt von r26 nach r27		
	cpi 	counter, 1			;Vergleiche Counter mit 1
	brne 	weiter91			;wenn nicht gesetzt gehe zu end1
	rcall 	VorkommaMulti		;*10
								;gehe zu Ende
weiter91:
	adiw 	vorkomma, neunx		;schreibe Wert in Vorkommaregister
	rjmp 	end91
nachkomma9:
	
	mov 	tempnach, r26
	cpi 	counter,2
	breq 	end9
	adiw 	nachkomma, neunx	;schreibe Wert in Nachkommaregister	
	rcall 	NachkommaMulti
end91:
	rcall 	clearpin
	inc 	counter
	ret
end9:
	ret

null: 		
	sbrc 	kommaset, 0			;berspringe n. Z. wenn kein Komma gesetzt
	rjmp 	nachkomma0			;wenn Komma gesetzt springe zu Nachkomma
	mov 	tempvor, r28		;kopiere Inhalt von r26 nach r27		
	cpi 	counter, 1			;Vergleiche Counter mit 1
	brne 	weiter01			;wenn nicht gesetzt gehe zu weiter01
	
	rcall 	VorkommaMulti		;*10
								;gehe zu Ende
weiter01:
	adiw 	vorkomma, nullx		;schreibe Wert in Vorkommaregister
	rjmp 	end01
nachkomma0:
	
	mov 	tempnach, r26
	cpi 	counter,2
	breq 	end0
	adiw 	nachkomma, nullx	;schreibe Wert in Nachkommaregister	
	rcall 	NachkommaMulti

end01:
	rcall 	clearpin
	inc 	counter
	ret
end0:
	ret

Komma:
	clr 	counter
	ser 	kommaset			;Kommaregister gesetzt 
	rcall 	clearpin
	ret

Enter:
	rcall 	clearpin
	rcall 	berechnung			;Berechnung aufrufen

end:
	ret

;  *WAIT*    ***************warte bis Taste gedrckt********************
wait:							
ldi 	zaehl, 0b00000001		;Abfrage der Tasten
nop								;Pause sonst wird die 7 nicht erkannt
nop
nop
nop
out 	porta, zaehl
nop
nop
rcall 	clear1
sbic 	pina, 4		;7
rjmp 	start
sbic 	pina, 5		;8
rjmp 	start	
rcall 	clear1
sbic 	pina, 6		;9
rjmp 	start
sbic 	pina, 7		;Up
rjmp 	loop1
inc 	zaehl
out 	porta, zaehl

rcall clear1

sbic 	pina, 4		;4
rjmp 	start
sbic 	pina, 5		;5
rjmp 	start	
sbic 	pina, 6		;6
rjmp 	start
sbic 	pina, 7		;Down
rjmp 	loop1
inc 	zaehl
inc 	zaehl

out 	porta, zaehl

rcall clear1

sbic 	pina, 4		;1
rjmp 	start	
sbic 	pina, 5		;2
rjmp 	start	
sbic 	pina, 6		;3
rjmp 	start
sbic 	pina, 7
rjmp 	loop1		;slowup
ldi 	zaehl, 0b0001000
out 	porta, zaehl

rcall clear1

sbic 	pina, 4		;Null
rjmp 	start
sbic 	pina, 5		;Komma
rjmp 	start
sbic 	pina, 6 	;Enter
rjmp 	start
sbic 	pina, 7		;slowdown
rjmp 	loop1
rjmp 	wait

;********************lsche pins****************************************
clear1:							;lsche Pins von PortA
	ser 	temp
	out 	DDRA, temp
	ldi 	temp, 0b00001111
	out 	DDRA, temp
	ret

;******lsche pins und warte bis kein Taster mehr gedrckt ist**********
clearpin:						;lscht Pins & bleibt in Schleife bis Taster 
	ser 	temp
	out 	DDRA, temp			;nicht mehr gedrckt ist
	ldi 	temp, 0b00001111
	out 	DDRA, temp			;lschen der Pins durch setzen des DDRs
	sbic 	pina, 4				;4	Prfung ob Taster noch gedrckt
	rjmp 	clearpin			;wiederhole 
	sbic 	pina, 5
	rjmp 	clearpin
	sbic 	pina, 6
	rjmp 	clearpin
	sbic 	pina, 7
	rjmp 	clearpin
	ret
	
;****************Multiplikation *10 der Vorkommazahlen*******************
Vorkommamulti:
	clr r0
	clr temp
	mov r30, vorkomma
	ldi temp, 10
	mul  r30, temp
	mov vorkomma, r0		;multiplikation schreibt Ergebnis immer nach r0
;	mov vk_save, vorkomma
	ret

Nachkommamulti:
	clr r0
	clr r1
	clr temp
	mov r30, nachkomma
	ldi temp, 10
	mul  r30, temp
	mov nachkomma, r0
	mov r29, r1
;	mov nk_save, nachkomma
	ret

;*****Berechnen der Bitkombination anhand der gewnschten Spannung******
Berechnung:						
;mov		vk_save, vorkomma
;mov		nk_save, nachkomma
clr 	r30
clr		r31
Teil1:
clr		temp
cpse	r26, temp
rcall 	Rechnung1
cpse 	r28, temp
rcall	Rechnung2
Teil2:
cpse	r29, temp
rcall	Rechnung3
rjmp 	Ausgang

Rechnung1:						;Voltzahl vor dem Komma wird umgerechnet
sbiw 	r26, 0b00000001
ldi		zaehl, 100
loop3:
cpse	zaehl, temp
rjmp	mach
rjmp 	Teil1
mach:
dec 	zaehl
adiw	r30, 10
rjmp 	loop3

Rechnung2:						;Voltzahl nach dem Komma wird umgerechnet
sbiw	r28, 0b00000001			
adiw	r30, 0b00000001
cpse	r28, temp
rjmp 	Teil1
rjmp	Teil2

Rechnung3:						;Voltzahl nach dem Komma wird umgerechnet
sbiw	r28, 0b00000001			
adiw	r30, 0b00000001
cpse	r28, temp
rjmp	Teil1
ret

Ausgang:						;Ausgabe an AD-Wandler
ldi		temp, 0b00000000		;chipselect aktiviert
out		PortC, temp
out 	PortB, r30
out 	PortD, r31
sbrs	menu_help, 0			;Rcksprung zum fortsetzen des Mens
rjmp 	menu_weiter1
sbrs	menu_help, 1
rjmp	menu_weiter2_1
sbrs	menu_help, 2
rjmp	menu_weiter2_2
sbrs	menu_help, 6
rjmp	menu_weiter3
sbrs	menu_help, 7
ret	


;***************Hoch/Runterzhlen*(Feinabstimmung)**********************
AnzeigeUP:
ret

Up:

cpi 	r31, 0b11111111			;verhindert dass overflow autritt (sprung von 30V auf 0V)
breq	full	 				;branch if equal	
adiw	r30, 0b00001000			;wenn noch nicht voll: Addiere .. auf r30
rjmp 	Ausgang
full:
rjmp loop1

SlowUp:

cpi 	r31, 0b11111111			;verhindert dass overflow autritt (sprung von 30V auf 0V)
breq	fullSlow	 			;branch if equal	
adiw	r30, 0b00000001			;wenn noch nicht voll: Addiere .. auf r30
;rcall 	clearpin
rjmp 	Ausgang
fullSlow:
rjmp loop1


AnzeigeDown:					
ret

Down:

cpi 	r31, 0b00000000			;verhindert dass overflow auftritt (sprung von 0V auf 30V)
breq	empty					;branch if equal
sbiw	r30, 0b00001000			;wenn noch nichtleer: Subtrahiere .. von r30		
rjmp	Ausgang
empty:
rjmp loop1

SlowDown:

cpi 	r31, 0b00000000			;verhindert dass overflow autritt (sprung von 30V auf 0V)
breq	emptySlow	 			;branch if equal	
sbiw	r30, 0b00000001			;enn noch nicht leer: Subtrahiere .. von r30
;rcall 	clearpin
rjmp 	Ausgang
emptySlow:
rjmp loop1

;** Eingebundene Dateien **

.include "lcd_ansteuerung.asm"
.include "timer.asm"
.include "menu.asm"
.include "tasten_einlesen.asm"
.include "variable_berechnen.asm"

